=== modules/imgproc/CMakeLists.txt ===
set(the_description "Image Processing")
ocv_define_module(imgproc opencv_core WRAP java python)
