=== modules/shape/CMakeLists.txt ===
set(the_description "Shape descriptors and matchers.")
ocv_define_module(shape opencv_core opencv_imgproc opencv_video WRAP python)
