=== debian/changelog ===
opencv (3.2.0+dfsg-4ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Out-of-bounds read/write errors and buffer
    overflows in different functions.
    - debian/patches/CVE-2017-several.patch: fix in bitstrm.cpp,
      bitstrm.hpp, grfmt_bmp.cpp, grfmt_pxm.cpp, loadsave.cpp,
      test_grfmt.cpp and cuda_test.cpp.
    - CVE-2016-1516
    - CVE-2016-1517
    - CVE-2017-12597
    - CVE-2017-12598
    - CVE-2017-12599
    - CVE-2017-12600
    - CVE-2017-12601
    - CVE-2017-12602
    - CVE-2017-12603
    - CVE-2017-12604
    - CVE-2017-12605
    - CVE-2017-12606
    - CVE-2017-12862
    - CVE-2017-12863
    - CVE-2017-12864
  * SECURITY UPDATE: Out of bound write cause segmentation fault
    - debian/patches/CVE-2017-14136.patch: fix in grfmt_bmp.cpp,
      grfmt_exr.cpp, grfmt_jpeg.cpp, grfmt_jpeg2000.cpp,
      grfmt_pam.cpp, grfmt_sunras.cpp, utils.cpp and utils.hpp.
    - CVE-2017-14136
  * SECURITY UPDATE: Buffer Overflow in the cv::PxMDecoder::readData
    function in grfmt_pxm.cpp
    - debian/patches/CVE-2017-17760.patch: fix in grfmt_pxm.cpp.
    - CVE-2017-17760
  * SECURITY UPDATE: Integer overflow may lead to remote execution or
    denial of service
    - debian/patches/CVE-2017-1000450.patch: fix in grfmt_bmp.cpp.
    - CVE-2017-1000450
  * SECURITY UPDATE: A heap-based buffer overflow happens in
    cv::Jpeg2KDecoder::readComponent8u when parsing a crafted image file
    - debian/patches/CVE-2018-5268.patch: fix in grfmt_jpeg2000.cpp.
    - CVE-2018-5268
  * SECURITY UPDATE: an assertion failure happens in
    cv::RBaseStream::setPos in modules/imgcodecs/src/bitstrm.cpp because
    of an incorrect integer cast.
    - debian/patches/CVE-2018-5269.patch: add overflow checks.
    - CVE-2018-5269

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Thu, 20 Sep 2018 06:28:13 -0300

opencv (3.2.0+dfsg-4build2) bionic; urgency=medium

  * No-change rebuild for tesseract soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Jan 2018 06:21:06 +0000

opencv (3.2.0+dfsg-4build1) bionic; urgency=medium

  * No-change rebuild for new gdal-abi-2-2-3..

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 17 Dec 2017 22:22:51 -0600

opencv (3.2.0+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Install maven artifacts with maven-repo-helper so reverse dependencies can
    automatically pick the dependency by using ${maven:Depends}.
    Thanks to Gilles Filippini <pini@debian.org> for the patch.  Closes: #878949
  * d/control:
    + Use unversioned Conflicts in libopencv-dev, to force the removal
      of some old packages.  Closes: #880921
    + Remove dbus-x11 work around now that #878878 is fixed.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 11 Nov 2017 13:46:48 +0100

opencv (3.2.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * d/p/support_multiarch: forward the patch after a small edit.
  * d/p/mathjax: make the MATHJAX_RELPATH option configurable at build time
    through cmake, and then forward the patch.
  * Despite tbb being available in all linux architectures, we need it in a
    version that is not available everywhere, so revert back to enabling it
    only on a hand-picked list of architectures.  Closes: #878830
  * d/control: work around #878878 in dbus by explictly adding dbus-x11 to
    build-deps for !linux.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 17 Oct 2017 16:27:02 +0200

opencv (3.2.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/patches:
    + support_x32 patch: drop, it actually did nothing useful.
    + fix_ftbfs_on_non_linux: simplify patch, by removing several hunks no
      longer needed.
      Incidentally, this fixes the FTBFS in x32.  Closes: #878705
  * d/rules:
    + Enable DICOM support.  Closes: #843513
    + tbb is now available in all linux archs, so enable it for all linux-any.
    + Enable SSE and SSE2 on all architectures based on a amd64 cpu, not just
      amd64 itself
    + Use /usr/share/dpkg/architecture.mk instead of calling dpkg-architecture.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 16 Oct 2017 23:44:22 +0200

opencv (3.2.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Bump Standards-Version to 4.1.1:
    + Use HTTPS in debian/copyright's Format field.
  * Use HTTPS for the Homepage URL.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 13 Oct 2017 19:32:01 +0200

opencv (3.2.0+dfsg-1~exp2) experimental; urgency=medium

  * Team upload.
  * Explicitly disable carotene support to fix FTBFS on arm*.
  * Drop conditional enabling of OpenGL, it can't be enabled with GTK+3
    anyway.  Closes: #869975
  * Changelog for 3.2.0+dfsg-1~exp2

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 31 Jul 2017 10:50:25 +0200

opencv (3.2.0+dfsg-1~exp1) experimental; urgency=medium

  * Update to 3.2.0.
    - Add freetype and phase_unwrapping modules into libopencv-contrib.
    - Disable DNN and tracking module (temporary).
  * Add patches/fix_VFP_asm.patch.
  * Update Standards-Version to 4.0.0.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 29 Jun 2017 09:42:02 +0900
